AllYourBase = {}
local AYB = AllYourBase
AYB.CurrentVersion = "0.0.4"

local me, race

AYB.CompletedQueue = {}

AYB.Main = CreateFrame("Frame","AllYourBaseMain")
AYB.Main.Timer = 0

AYB.Model = CreateFrame("Model", nil, UIParent)
local model = AYB.Model

for k, v in pairs({
	"ADDON_LOADED",
	"PLAYER_ENTERING_WORLD",
	"GARRISON_ARCHITECT_CLOSED",
	"GARRISON_ARCHITECT_OPENED",
	"GARRISON_BUILDINGS_SWAPPED",
	"GARRISON_BUILDING_ACTIVATABLE",
	"GARRISON_BUILDING_ACTIVATED",
	"GARRISON_BUILDING_ERROR",
	"GARRISON_BUILDING_LIST_UPDATE",
	"GARRISON_BUILDING_PLACED",
	"GARRISON_BUILDING_REMOVED",
	"GARRISON_BUILDING_UPDATE",
	"GARRISON_FOLLOWER_ADDED",
	"GARRISON_FOLLOWER_LIST_UPDATE",
	"GARRISON_FOLLOWER_REMOVED",
	"GARRISON_FOLLOWER_XP_CHANGED",
	"GARRISON_HIDE_LANDING_PAGE",
	"GARRISON_INVASION_AVAILABLE",
	"GARRISON_INVASION_UNAVAILABLE",
	"GARRISON_LANDINGPAGE_SHIPMENTS",
	"GARRISON_MISSION_BONUS_ROLL_COMPLETE",
	"GARRISON_MISSION_BONUS_ROLL_LOOT",
	"GARRISON_MISSION_COMPLETE_RESPONSE",
	"GARRISON_MISSION_FINISHED",
	"GARRISON_MISSION_LIST_UPDATE",
	"GARRISON_MISSION_NPC_CLOSED",
	"GARRISON_MISSION_NPC_OPENED",
	"GARRISON_MISSION_STARTED",
	"GARRISON_MONUMENT_CLOSE_UI",	
	"GARRISON_MONUMENT_LIST_LOADED",
	"GARRISON_MONUMENT_REPLACED",
	"GARRISON_MONUMENT_SELECTED_TROPHY_ID_LOADED",
	"GARRISON_MONUMENT_SHOW_UI",
	"GARRISON_RECALL_PORTAL_LAST_USED_TIME",
	"GARRISON_RECALL_PORTAL_USED",
	"GARRISON_RECRUITMENT_FOLLOWERS_GENERATED",
	"GARRISON_RECRUITMENT_NPC_CLOSED",
	"GARRISON_RECRUITMENT_NPC_OPENED",
	"GARRISON_RECRUITMENT_READY",
	"GARRISON_RECRUIT_FOLLOWER_RESULT",
	"GARRISON_SHOW_LANDING_PAGE",
	"GARRISON_TRADESKILL_NPC_CLOSED",
	"GARRISON_UPDATE",
	"GARRISON_UPGRADEABLE_RESULT",
	"GARRISON_USE_PARTY_GARRISON_CHANGED"}) do AYB.Main:RegisterEvent(v) end
	
function AYB.Main.OnEvent(self, event, ...)
	if event == "GARRISON_MISSION_STARTED" then
		AYB.StartMission(...)
	elseif event == "GARRISON_BUILDING_PLACED" then
		AYB.StartBuilding(...)
	elseif event == "GARRISON_MISSION_COMPLETE_RESPONSE" then
		AYB.RemoveCompletedMission(...)
	elseif event == "ADDON_LOADED" then
		if ... == "AllYourBase" then
			me = UnitName("player").."-"..GetRealmName()
			race = select(2, UnitRace("player"))
			if (not AllYourBaseVars) or (AllYourBaseVars.CurrentVersion ~= AYB.CurrentVersion) then
				AllYourBaseVars = {}
				AllYourBaseVars.CurrentVersion = AYB.CurrentVersion
			end
			if not AllYourBaseVars[me] then
				AllYourBaseVars[me] = {
					["Buildings"] = {},
					["Shipments"] = {},
					["Missions"] = {},
					["Followers"] = {},
					["Race"] = race
				}
			end
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		AYB.Main:Show()
		model:SetHeight(100)
		model:SetWidth(100)
		model:Show()
		AYB.CleanUpUnusedEntries("Missions")
		AYB.CleanUpUnusedEntries("Buildings")
	--else
		--print(event, ...)
	end
end

function AYB.Main.OnUpdate(self, timer)
	AYB.Main.Timer = AYB.Main.Timer + timer
	if AYB.Main.Timer >= 5 then
		AYB.Main.Timer = 0
		AYB.SyncMissions()
	end
end

AYB.Main:SetScript("OnEvent", AYB.Main.OnEvent)
AYB.Main:SetScript("OnUpdate", AYB.Main.OnUpdate)

function AYB.StartMission(...)
	local started = ...
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.missionID == started then
			AllYourBaseVars[me].Missions[started] = v
			AllYourBaseVars[me].Missions[started]["startTime"] = time()
			local timeLeft = v.timeLeft
			local hr, mins, secs
			if string.find(timeLeft, "hr") then
				hr = string.match(timeLeft, "(%d+) hr")
			end
			if string.find(timeLeft, "min") then
				mins = string.match(timeLeft, "(%d+) min")
			end
			hr = hr or 0; mins = mins or 0
			secs = (hr * 3600) + (mins * 60)
			AllYourBaseVars[me].Missions[started].endTime = time() + secs
			AllYourBaseVars[me].Missions[started].hasBroadcast = false
		end
	end
end

function AYB.StartBuilding(...)
	--local t = {...}
	--print("BUILDING START "..unpack(t))
end

function AYB.DisplayCompletedSingleMission(char, missionID)
	GarrisonLandingPageMinimapButton.MinimapLoopPulseAnim:Play();
	local missionInfo = AllYourBaseVars[char].Missions[missionID];
	GarrisonMissionAlertFrame.Name:SetText(missionInfo.name);
	GarrisonMissionAlertFrame.MissionType:SetAtlas(missionInfo.typeAtlas);
	AlertFrame_AnimateIn(GarrisonMissionAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_MissionComplete");
end

function AYB.DisplayCompletedMultiMission()
	local done, chars, toonCount, whichToon, msg, toon = {}, {}, 1
	for k, v in ipairs(AYB.CompletedQueue) do
		toon = string.match(v, "([^/]+)")
		-- local toon = string.match(key, "([^-]+)")
		-- print(key, toon)
		if not done[toon] then
			done[toon] = 0
			tinsert(chars, toon)
		end
		done[toon] = done[toon] + 1
	end
	whichToon = chars[random(1, #chars)]
	local myRace = AllYourBaseVars[whichToon].Race
	local total = (#chars > 1 and ", for a total of "..#AYB.CompletedQueue.." missions.") or "."
	local intro = AllYourBase.StatusIntros[myRace][random(#AllYourBase.StatusIntros[myRace])]
	msg = intro
	for k, v in pairs(done) do
		local sp = (v == 1 and "mission") or "missions"
		local punc = (toonCount == (#chars - 1) and ", and") or "."
		local subj = (k == whichToon and "I") or k:match("([^-]+)")
		local verb = (k == whichToon and " have completed ") or " has completed "
		msg = msg.." ".. subj .. verb ..v.." ".. sp .. punc
		toonCount = toonCount + 1
	end
	msg = string.sub(msg, 1, string.len(msg) - 1).. total
	AYB.FakeWhisper(whichToon, msg)
end

function AYB.SyncMissions()
	AYB.AddAnyMissing()
	AYB.SearchAllForComplete()
end

function AYB.AddAnyMissing()
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.isBuilding == false then -- if this is not a Building, it's a Mission
			if not AllYourBaseVars[me].Missions[v.missionID] then
				AllYourBaseVars[me].Missions[v.missionID] = v
				AllYourBaseVars[me].Missions[v.missionID]["startTime"] = "unknown"
				local timeLeft = C_Garrison.GetLandingPageItems()[k]["timeLeft"]
				local hr, mins, secs
				if string.find(timeLeft, "hr") then
					hr = string.match(timeLeft, "(%d+) hr")
				end
				if string.find(timeLeft, "min") then
					mins = string.match(timeLeft, "(%d+) min")
				end
				hr = hr or 0; mins = mins or 0
				secs = (hr * 3600) + (mins * 60)
				AllYourBaseVars[me].Missions[v.missionID].endTime = time() + secs
				AllYourBaseVars[me].Missions[v.missionID].hasBroadcast = false
			end
		else -- it's a Building
			if not AllYourBaseVars[me].Buildings[v.name] then
				AllYourBaseVars[me].Buildings[v.name] = v
				AllYourBaseVars[me].Buildings[v.name]["startTime"] = "unknown"
				local timeLeft = C_Garrison.GetLandingPageItems()[k]["timeLeft"]
				local hr, mins, secs
				if string.find(timeLeft, "hr") then
					hr = string.match(timeLeft, "(%d+) hr")
				end
				if string.find(timeLeft, "min") then
					mins = string.match(timeLeft, "(%d+) min")
				end
				hr = hr or 0; mins = mins or 0
				secs = (hr * 3600) + (mins * 60)
				AllYourBaseVars[me].Buildings[v.name].endTime = time() + secs
				AllYourBaseVars[me].Buildings[v.name].hasBroadcast = false
			end
		end
	end
end

--[[ function AYB.DeleteCurrentCharUnused()
	for k, v in pairs(AllYourBaseVars[me].Missions) do
		local missionID = v.missionID
		local buildingName = (v.isBuilding and v.name)
		local isActive = nil
		for l, w in ipairs(C_Garrison.GetLandingPageItems()) do
			if (missionID and w.missionID == missionID) or (buildingName and w.name == buildingName) then
				isActive = true
				break
			end
		end
		if not isActive then
			if buildingName then
				AllYourBaseVars[me][buildingName] = nil
			elseif missionID then
				AllYourBaseVars[me][missionID] = nil
			end
		end
	end
end ]]

function AYB.RemoveCompletedMission(missionID)
	print(format("Removing %s from %s!", missionID, me))
	AllYourBaseVars[me].Missions[missionID] = nil
end

function AYB.CleanUpUnusedEntries(dataType)
	for k, v in pairs(AllYourBaseVars[me][dataType]) do
		local ID = v.missionID
		local isActive = nil
		for l, w in ipairs(C_Garrison.GetLandingPageItems()) do
			if ID == w.missionID then
				isActive = true
				break
			end
		end
		if not isActive then
			AllYourBaseVars[me][dataType][ID] = nil
		end
	end
end

function AYB.SearchAllForComplete()
	local somethingComplete
	for k, v in pairs(AllYourBaseVars) do
		if k ~= me and k~= "CurrentVersion" then
			for l, w in pairs(v.Missions) do
				if time() >= w.endTime and w.hasBroadcast == false then
					w.hasBroadcast = true
					tinsert(AYB.CompletedQueue, k.."/"..w.missionID)
					somethingComplete = true
				end
			end
		end
	end
	if somethingComplete then
		if #AYB.CompletedQueue > 1 then
			AYB.DisplayCompletedMultiMission()
		else
			local toon, missionID = string.match(AYB.CompletedQueue[1], "([^/]+)/(%d+)")
			AYB.DisplayCompletedSingleMission(toon, tonumber(missionID))
			AYB.FakeWhisper(toon, "Job's done!")
			tremove(AYB.CompletedQueue)
		end
	end
end

function AYB.FakeWhisper(character, msg)
	ChatFrame_MessageEventHandler(ChatFrame1, "CHAT_MSG_WHISPER", msg, character, "Orcish", "", "", "", "", "", "", "", "1")
	PlaySound("TellMessage")
end